#ifndef MISC_H
#define MISC_H

#ifndef MIN
#define MIN(x, y) (((x) < (y)) ? (x) : (y))
#endif

#ifndef MAX
#define MAX(x, y) (((x) > (y)) ? (x) : (y))
#endif

/* converts hexidecimal string to binary */
char *hex_string_to_bin(const char *hex_string);

/* copies data to msg buffer.
   returns length of msg, which will be no larger than size-1 */
uint16_t copy_tox_str(char *msg, size_t size, const char *data, uint16_t length);

/* returns index of the first instance of ch in s starting at idx.
   returns length of s if char not found */
int char_find(int idx, const char *s, char ch);

/* add msg time */
void log_msg(Tox *tox, const uint8_t *msg, uint32_t friend_number, bool user);

/*
 * Searches plain text file pointed to by path for lines that match public_key.
 *
 * Returns 1 if a match is found.
 * Returns 0 if a match is not found.
 * Returns -1 on file operation failure.
 *
 * public_key must be a binary representation of a Tox public key.
 */
int file_contains_key(const char *public_key, const char *path);

#endif /* MISC_H */
